package me.Demon.DemonPay.command;

import cn.hamster3.cdapi.CDTimeAPI;
import me.Demon.DemonPay.Main;
import me.Demon.DemonPay.PLimitData;
import me.Demon.DemonPlugin.DemonAPI;
import org.bukkit.Bukkit;
import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

public class DpayCommand implements CommandExecutor {

    @Override
    public boolean onCommand(CommandSender sender, Command command, String label, String[] args) {
        String prefix = Main.prefix;
        Player p = (Player) sender;
        if(!p.hasPermission("demonpay.points")){
            sender.sendMessage(prefix+"你需要成为 §c【领域炼金师】 §f才能使用此命令.");
            return true;
        }
        if (args.length == 2) {
            if(!Main.isInt(args[1])){
                sender.sendMessage(prefix+"正确用法: §a/dpay [玩家ID] [金额]");
                return true;
            }
            Player otherPlayer = Bukkit.getPlayer(args[0]);
            if (otherPlayer == null) {
                sender.sendMessage(prefix + "目标玩家不在线");
                return true;
            }
            if (p.getName().equalsIgnoreCase(otherPlayer.getName())){
                sender.sendMessage(prefix + "无法向自己发起转账");
                return true;
            }
            if (CDTimeAPI.getCD(p.getUniqueId(), "PayCD") > 0) {
                sender.sendMessage(prefix + "支付系统正在冷却...");
                return true;
            }
            int points = Integer.parseInt(args[1]);
            if (points < 5) {
                sender.sendMessage(prefix + "支付金额必须大于 §d5.0点券");
                return true;
            }
            if (!DemonAPI.hasPoints(p, points)) {
                sender.sendMessage(prefix + "没有足够的点券!");
                return true;
            }
            // 若无此权限将会进行额度检测
            if(!p.hasPermission("demonpay.pointspro")) {
                if (Main.dataAPI.get(p) == null) {
                    Main.dataAPI.put(p, new PLimitData(p));
                }
                PLimitData dataAPI = Main.dataAPI.get(p);
                int limit = dataAPI.getLimit();
                int newLimit = limit - points;
                if (newLimit <= -1) {
                    sender.sendMessage(prefix+"转账失败,您的今日点券额度不足.");
                    return true;
                }
                dataAPI.setLimit(newLimit);
            }
            DemonAPI.takePoints(p, points);
            DemonAPI.givePoints(otherPlayer, points);
            CDTimeAPI.setPlayerCD(p.getUniqueId(),"PayCD",1000 * 10);
            sender.sendMessage(prefix+"你向 §a" + otherPlayer.getName() + " §f支付了 §a" + points + " §f点券");
            otherPlayer.sendMessage(prefix+"你从 §a" + sender.getName() + " §f收到了 §a" + points + " §f点券");
        } else {
            sender.sendMessage(prefix+"正确用法: §a/dpay [玩家ID] [金额]");
        }
        return false;
    }
}
